// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dialogflow/cx/v3/flow.proto

#include "google/cloud/dialogflow_cx/flows_connection_idempotency_policy.h"
#include "absl/memory/memory.h"
#include <memory>

namespace google {
namespace cloud {
namespace dialogflow_cx {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

FlowsConnectionIdempotencyPolicy::~FlowsConnectionIdempotencyPolicy() = default;

namespace {
class DefaultFlowsConnectionIdempotencyPolicy
    : public FlowsConnectionIdempotencyPolicy {
 public:
  ~DefaultFlowsConnectionIdempotencyPolicy() override = default;

  /// Create a new copy of this object.
  std::unique_ptr<FlowsConnectionIdempotencyPolicy> clone() const override {
    return absl::make_unique<DefaultFlowsConnectionIdempotencyPolicy>(*this);
  }

  Idempotency CreateFlow(
      google::cloud::dialogflow::cx::v3::CreateFlowRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency DeleteFlow(
      google::cloud::dialogflow::cx::v3::DeleteFlowRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency ListFlows(
      google::cloud::dialogflow::cx::v3::ListFlowsRequest) override {
    return Idempotency::kIdempotent;
  }

  Idempotency GetFlow(
      google::cloud::dialogflow::cx::v3::GetFlowRequest const&) override {
    return Idempotency::kIdempotent;
  }

  Idempotency UpdateFlow(
      google::cloud::dialogflow::cx::v3::UpdateFlowRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency TrainFlow(
      google::cloud::dialogflow::cx::v3::TrainFlowRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency ValidateFlow(
      google::cloud::dialogflow::cx::v3::ValidateFlowRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency GetFlowValidationResult(
      google::cloud::dialogflow::cx::v3::GetFlowValidationResultRequest const&)
      override {
    return Idempotency::kIdempotent;
  }

  Idempotency ImportFlow(
      google::cloud::dialogflow::cx::v3::ImportFlowRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency ExportFlow(
      google::cloud::dialogflow::cx::v3::ExportFlowRequest const&) override {
    return Idempotency::kNonIdempotent;
  }
};
}  // namespace

std::unique_ptr<FlowsConnectionIdempotencyPolicy>
MakeDefaultFlowsConnectionIdempotencyPolicy() {
  return absl::make_unique<DefaultFlowsConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dialogflow_cx
}  // namespace cloud
}  // namespace google
