// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dialogflow/cx/v3/security_settings.proto

#include "google/cloud/dialogflow_cx/security_settings_connection_idempotency_policy.h"
#include "absl/memory/memory.h"
#include <memory>

namespace google {
namespace cloud {
namespace dialogflow_cx {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

SecuritySettingsServiceConnectionIdempotencyPolicy::
    ~SecuritySettingsServiceConnectionIdempotencyPolicy() = default;

namespace {
class DefaultSecuritySettingsServiceConnectionIdempotencyPolicy
    : public SecuritySettingsServiceConnectionIdempotencyPolicy {
 public:
  ~DefaultSecuritySettingsServiceConnectionIdempotencyPolicy() override =
      default;

  /// Create a new copy of this object.
  std::unique_ptr<SecuritySettingsServiceConnectionIdempotencyPolicy> clone()
      const override {
    return absl::make_unique<
        DefaultSecuritySettingsServiceConnectionIdempotencyPolicy>(*this);
  }

  Idempotency CreateSecuritySettings(
      google::cloud::dialogflow::cx::v3::CreateSecuritySettingsRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency GetSecuritySettings(
      google::cloud::dialogflow::cx::v3::GetSecuritySettingsRequest const&)
      override {
    return Idempotency::kIdempotent;
  }

  Idempotency UpdateSecuritySettings(
      google::cloud::dialogflow::cx::v3::UpdateSecuritySettingsRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency ListSecuritySettings(
      google::cloud::dialogflow::cx::v3::ListSecuritySettingsRequest) override {
    return Idempotency::kIdempotent;
  }

  Idempotency DeleteSecuritySettings(
      google::cloud::dialogflow::cx::v3::DeleteSecuritySettingsRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }
};
}  // namespace

std::unique_ptr<SecuritySettingsServiceConnectionIdempotencyPolicy>
MakeDefaultSecuritySettingsServiceConnectionIdempotencyPolicy() {
  return absl::make_unique<
      DefaultSecuritySettingsServiceConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dialogflow_cx
}  // namespace cloud
}  // namespace google
