// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dialogflow/v2/knowledge_base.proto

#include "google/cloud/dialogflow_es/knowledge_bases_connection_idempotency_policy.h"
#include "absl/memory/memory.h"
#include <memory>

namespace google {
namespace cloud {
namespace dialogflow_es {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

KnowledgeBasesConnectionIdempotencyPolicy::
    ~KnowledgeBasesConnectionIdempotencyPolicy() = default;

namespace {
class DefaultKnowledgeBasesConnectionIdempotencyPolicy
    : public KnowledgeBasesConnectionIdempotencyPolicy {
 public:
  ~DefaultKnowledgeBasesConnectionIdempotencyPolicy() override = default;

  /// Create a new copy of this object.
  std::unique_ptr<KnowledgeBasesConnectionIdempotencyPolicy> clone()
      const override {
    return absl::make_unique<DefaultKnowledgeBasesConnectionIdempotencyPolicy>(
        *this);
  }

  Idempotency ListKnowledgeBases(
      google::cloud::dialogflow::v2::ListKnowledgeBasesRequest) override {
    return Idempotency::kIdempotent;
  }

  Idempotency GetKnowledgeBase(
      google::cloud::dialogflow::v2::GetKnowledgeBaseRequest const&) override {
    return Idempotency::kIdempotent;
  }

  Idempotency CreateKnowledgeBase(
      google::cloud::dialogflow::v2::CreateKnowledgeBaseRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency DeleteKnowledgeBase(
      google::cloud::dialogflow::v2::DeleteKnowledgeBaseRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency UpdateKnowledgeBase(
      google::cloud::dialogflow::v2::UpdateKnowledgeBaseRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }
};
}  // namespace

std::unique_ptr<KnowledgeBasesConnectionIdempotencyPolicy>
MakeDefaultKnowledgeBasesConnectionIdempotencyPolicy() {
  return absl::make_unique<DefaultKnowledgeBasesConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dialogflow_es
}  // namespace cloud
}  // namespace google
